/**
 * 控制台打印输出进度
 */

let label = ''
let spinner

/**
 * 初始化显示
 */
exports.show = mode => {
  switch (mode) {
    case 'development':
      label = `Starting development server`
      break
    case 'production':
      label = `Building for production`
      break
  }
  spinner = require('ora')(`${label} 0%`).start()
}

/**
 * 设置进度
 */
exports.setProgress = percentage => {
  spinner.text = `${label} ${parseInt(percentage * 100)}%`
}

/**
 * webpack 插件
 */
exports.plugin = class ProgressPlugin {
  apply (compiler) {
    compiler.hooks.done.tap('Progress Plugin', stats => {
      spinner.stop()
    })
  }
}
