/**
 * webpack 配置工厂
 */

const Config = require('webpack-chain')
const { getMode, getSourceMap } = require('../common/util')

module.exports = () => {
  const config = new Config()
  const sourceMap = getSourceMap()

  // mode
  config.mode(getMode())

  // devtool
  sourceMap && config.devtool(sourceMap)

  // entry
  require('./entry')({ config })

  // output
  require('./output')({ config })

  // rule
  require('./rule')({ config })

  // plugin
  require('./plugin')({ config })

  // resolve
  require('./resolve')({ config })

  return config
}
